/* gkf winified 25jun2K with orb 13aug */
/* illiTangle tngl.c 5-30-00 */
/****************************************************************/
/****    skel.c = OpenSkelGlut.c = Noosh97 with CAVE removed ****/
/****    (C) 1994 Board of Trustees University of Illinois   ****/ 
/****    A Model Real-Time Interactive OpenGL Application    ****/
/****    George Francis, Glenn Chappell, Chris Hartman       ****/
/****    e-mail  gfrancis@math.uiuc.edu                      ****/
/******* revised 16jan2K by gkf**********************************/
/****************************************************************/
#pragma warning (disable:4305)  /* double-to-float  */
#pragma warning (disable:4101)	/* unreferenced local variable */
#pragma warning (disable:4056)	/* overflow in fp constant arithmetic */
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <sys/timeb.h>    /* for the speedometer */
#include <gl/glut.h>
#define  MAX(x,y)         (((x)<(y))?(y):(x))
#define  MIN(x,y)         (((x)<(y))?(x):(y))
#define  ABS(u)           ((u)<0 ? -(u): (u))
#define  FOR(a,b,c)       for((a)=(b);(a)<(c);(a)++)
#define  DOT(p,q)         ((p)[0]*(q)[0]+(p)[1]*(q)[1]+(p)[2]*(q)[2])
#define  NRM(p)           sqrt(DOT((p),(p)))
#define  M_PI          (355/115)
#define  DG            M_PI/180
#define  S(u)          sin(u*DG)
#define  C(u)          cos(u*DG)
#define  CLAMP(x,u,v) (x<u? u : (x>v ? v: x))
/* global variables */
float gap, gap0=1.; /* kludge so that arguments() can set a default gap0 */
float lux[3]={.3,.5,.8};             /*world light direction vector     */
float luxx[3];                       /*  object space  direction vector*/
float amb, pwr ;             /* ambient fraction, pseudo-specular power */
float mysiz,speed, torq, focal, farr; /*console navigation variables         */
int win = 0;                   /* 2 full screen, use 0 for demand sized */
int knopf=0;
unsigned int BUT, XX, YY,SHIF;     /* used in chaptrack gluttery           */ 
int xt,yt;                       /* once was xt,yt,xm,ym for viewportery */
int mode,morph,msg,binoc;            /* pretty global */
int th0, th1, dth, ta0, ta1, dta;    /* torus parameters */
int umm, rndr ; /* an index in 0,1,2, and renderflag */
float beta, heta, dheta, rh1, rh0; 
#define FLYMODE  (0)
#define TURNMODE (1) 
int ii, jj, kk;  float tmp, temp;   /* saves gray hairs later */
float aff[16], starmat[16], mat[16]; 
int binoc;    /* flag                       */
float nose;   /* to eye distance in console */
/**********************************************************************/
void autotymer(int reset){ /* cheap animations */
#define  TYME(cnt,max,act) {static cnt; if(first)cnt=max; else\
                            if(cnt?cnt--:0){ act ; goto Break;}}
  static first = 1;  /* the first time autymer is called */
  if(reset)first=1;  /* or if it is reset to start over  */
  TYME( unfurl , 188,heta+=1.0)    /*188.5 ... don't ask why */
  TYME( pause  , 20,          )
  TYME( refurl , 188,heta+=1.0)
  TYME( pause  , 20,          )
  TYME( uncurl , 100,beta -=.01)
  TYME( pause  , 20,          )
  TYME( curl , 100,beta +=.01)
  TYME( pause  , 20,          )
  TYME(finish  , 1 , first = 1  )
  first = 0;
  Break:   ;   /* yes Virginia, C has gotos */
}
/**********************************************************************/
int cdth, fdth, cdta, fdta; 
/**********************************************************************/
void deFault(void){
   knopf = 0;
/* surface patch */
    beta = 1.0; heta=0.; dheta=1.; gap = gap0;
   th0 = -20 ; th1 =  20; cdth=20; fdth= 10 ; dth = fdth;
   ta0 = -200 ; ta1 = 200; cdta=20; fdta= 2; dta = fdta;
   rh0 = .25 ;  rh1 = 2.; rndr = 1; umm = 0;

msg=1; binoc=0; nose=.06; mode=TURNMODE;  
speed=.05; torq=.01; focal = 2.; farr =33.; mysiz=.01; morph=0; 
FOR(ii,0,16) starmat[ii]=aff[ii] = (ii/4==ii%4);   /* identities */ 
FOR(ii,0,3)lux[ii]/=NRM(lux); amb = .3; pwr = 10. ;
aff[12]=0; aff[13]= 0; aff[14]= -4.2;   /* place where we can see it */
autotymer(1); /* reset autotymer to start at the beginning */
}
/**********************************************************************/
void drawvert(int th, int ta){  
float lmb,spec,nn[3], dog, cat;
nn[0] = C(th)*C(ta); /* unit sphere radius vector */  
nn[1] = S(th)*C(ta);
nn[2] =       S(ta);
lmb = DOT(nn,luxx);lmb =(lmb<0 ? .2 : lmb);  lmb = MAX(amb, lmb); 
spec = CLAMP((1.1 - pwr+pwr*lmb), 0., 1.);  
dog = (float)(ta-ta0)/(float)(ta1-ta0); cat = (float)(th-th0)/(float)(th1-th0);
glColor3f(
  MAX(spec, lmb*dog),                    /* map R^2(dog,cat)->R^3(RGBspace */
  MAX(spec, lmb*(.25 + ABS(cat -.5))),  /* dog cat model of Hartman       */
  MAX(spec, lmb*(1 - cat)));            /* illiLight by Ray Idaszak 1989  */
glVertex3f(
  C(th) + .5*nn[0],
  S(th) + .5*nn[1],
          .5*nn[2]);
} /* end drawvert */
/**********************************************************************/
void drawtor(void){
int th, ta;
dth = (int)((th1-th0)/24);  /* 24  meridian strips */ 
dta = (int)((ta1-ta0)/24);  /* 24  triangle pairs per strip */
for(th=th0; th < th1; th += dth){
  glBegin(GL_TRIANGLE_STRIP);
  for(ta=ta0; ta < ta1; ta += dta){ drawvert(th,ta); drawvert(th+gap*dth,ta); }
  glEnd();
  } /* end for.theta loop */
}   /* end drawtor */
/**********************************************************************/
void drawcube(void){ /* transfer from skel.c as an exercise  */ }
/**********************************************************************/
/* mapping to a ribbon */
void ribbon(float vv[3],int th,int ta)
    { int inx; float rr, v1,v2,v3,a1,a2,a3,s2,c2,tmp,rh, lambda;
/*  ribbon  */
   vv[umm]       = 0.; 
   vv[(umm+1)%3] = .01*th; 
   vv[(umm+2)%3] = .01*ta; 

/* spherical radius of point */
   rh = NRM(vv);
   rr = (rh1-rh)/(rh1-rh0); 
   lambda = beta*M_PI*(1-C(180*rr));  /* ogived  rr*/ 
   c2 = cos(lambda); s2 = sin(lambda);

/* twisted spherical shell */
   v1 = vv[0]*c2 - s2*vv[1];
   v2 = vv[1]*c2 + s2*vv[0];
   v3 = vv[2];

/*  Kauffman's quator: rot(lambda,axis) */
        a1 = sin(heta*DG);
        a2 = 0;
        a3 = cos(heta*DG);
        tmp  =(1-c2)*(v1*a1+v2*a2+v3*a3);
        vv[0]= v1*c2 + s2*(a2*v3-a3*v2) + tmp*a1;
        vv[1]= v2*c2 + s2*(a3*v1-a1*v3) + tmp*a2;
        vv[2]= v3*c2 + s2*(a1*v2-a2*v1) + tmp*a3;
}

/**********************************************************************/
void paint(float lmb,float dog,float cat){  /* note dog and cat float 0..1 */
     float rr,gg,bb; float spec;
     rr = dog;                                /* Chris Hartman, 1991 */      
     gg = ABS(cat - 0.5) + .25;
     bb = 1. - cat;
     lmb = MAX(lmb,amb);
     spec=MIN(1.,( 1. - pwr + pwr*lmb));  /* Ray Idaszak, 1988 */
     rr = MAX(lmb*rr, spec);
     gg = MAX(lmb*gg, spec);
     bb = MAX(lmb*bb, spec);
     glColor3f(rr,gg,bb);
   }
/**********************************************************************/

/**********************************************************************/
void drawsurf(void(*surf)(),
     int th0,int th1,int dth, int ta0, int ta1, int dta, int gap, int rndr) 
{
  int th, ta; float dog, vv[3], aa[3], vo[3], nn[3], lmb;
  for(th=th0; th < th1; th += dth){
    if(rndr)glBegin(GL_TRIANGLE_STRIP);
        dog = (float)(th-th0)/(th1-th0); paint(.8,dog, 0);
        (*surf)(vo,th,ta0); glVertex3fv(vo);            /* first vertex */
        (*surf)(aa,th+dth-gap,ta0); glVertex3fv(aa);            /* first rung */
    for(ta = ta0+dta; ta <= ta1; ta += dta){ 
       (*surf)(vv,th,ta );                   /* normal on vo aa vv */
       nn[0]=(aa[1]-vv[1])*(vo[2]-vv[2])-(aa[2]-vv[2])*(vo[1]-vv[1]);
       nn[1]=(aa[2]-vv[2])*(vo[0]-vv[0])-(aa[0]-vv[0])*(vo[2]-vv[2]);
       nn[2]=(aa[0]-vv[0])*(vo[1]-vv[1])-(aa[1]-vv[1])*(vo[0]-vv[0]);
       lmb = DOT(luxx,nn)/NRM(nn); if(lmb<0.)lmb = -lmb;
       paint(lmb, dog,(float)(ta-ta0)/(ta1-ta0));
  if(!rndr){
           glBegin(GL_LINE_STRIP); 
           glVertex3fv(vo); glVertex3fv(vv);
           } /* rail */ 
           glVertex3fv(vv); 
           (*surf)(aa,th+dth-gap,ta); glVertex3fv(aa);   /*subsequent rung*/

       vo[0]=vv[0]; vo[1]=vv[1]; vo[2]=vv[2];
       if(!rndr)glEnd(); 
   } /* end tau loop */ 
  if(rndr)glEnd();
 } /* end theta loop */
} 

/**********************************************************************/
/* draw outside orb */
void draworb(void){ int ii,jj; float vv[3];
    FOR(ii,0,3){
/*
    lRGBrange(50*(ii!=0),50*(ii!=1),50*(ii!=2),
              255*(ii!=0),255*(ii!=1),255*(ii!=2),znear,zfar);
    linewidth(thick); depthcue(1);
*/
      glBegin(GL_LINE_STRIP); FOR(jj,0,128){
               vv[ii]= 0.;
               vv[(ii+1)%3]= rh1*sin((float)jj*M_PI/64);
               vv[(ii+2)%3]= rh1*cos((float)jj*M_PI/64);
               glVertex3fv(vv);
      } glEnd();  /* depthcue(0); */
    }
}
/**********************************************************************/
void drawall(void){ /* drawtor(); drawcube(); */ 
      int the_umm = umm;
      drawsurf(ribbon, th0, th1, dth, ta0, ta1, dta, gap, rndr);
      umm = (umm+1) % 3;
      drawsurf(ribbon, th0, th1, dth, ta0, ta1, dta, gap, rndr);
      umm = the_umm;  /* kludge ... this is the wrong tngl.c */ 
      
      draworb();
}

/**********************************************************************/
void drawstars(void){ 
     static float star[1000][3]; static int virgin=1;
 if(virgin){  /* first time  set up the stars */
     FOR(ii,0,1000)FOR(jj,0,3)star[ii][jj]=rand()/(float)0x40000000-1.;
     virgin=0; /* never again */
  }
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();   /* insurance of superstition */
  glMultMatrixf(starmat);
  glColor3f(1.0,1.0,0.0);    
  glBegin(GL_POINTS);
    FOR(ii,0,1000)glVertex3fv(star[ii]);
  glEnd();
  glPopMatrix();
  glClear(GL_DEPTH_BUFFER_BIT); /* so the stars are behind everything */
}
/**********************************************************************/
void arguments(int argc,char **argv){
#if 0 
  extern char *optarg;
  extern int optind; 
  int chi;   
  /* w: needs ONE number after -w, c<nothing> means NO number follows*/ 
  while ((chi = getopt(argc,argv,"w:d:g:")) != -1) 
  switch(chi)  {
                case 'w': win=atoi(optarg); break; 
                case 'g': gap0=atof(optarg); break;
                }
  if (optind!=argc) fprintf(stderr,"%s: Incorrect usage\n",argv[0]);
#endif
}
/**********************************************************************/
void keyboard(unsigned char key, int x, int y){
#define  IF(K)            if(key==K)
#define  PRESS(K,A,b)     IF(K){b;}IF((K-32)){A;}  
/*was backwards in previous versions */
#define  TOGGLE(K,flg)    IF(K){(flg) = 1-(flg); }
#define  CYCLE(K,f,m)     PRESS((K), (f)=(((f)+(m)-1)%(m)),(f)=(++(f)%(m)))
#define  SLIDI(K,f,m,M)   PRESS(K,(--f<m?m:f), (++f>M?M:f))
#define  SLIDF(K,f,m,M,d) PRESS(K,((f -= d)<m?m:f), ((f += d)>M?M:f))
/* Only ASCII characters can be processes by this GLUT callback function */ 
   IF(27) { exit(0); }              /* ESC exit            */
   TOGGLE('v',binoc);                            /* cross-eyed STEREO   */
   CYCLE(' ', mode,TURNMODE+1);                  /* fly/turn modes      */
   TOGGLE('m',morph);                            /* autotymer on/off    */
   TOGGLE('w',msg);                              /* writing on/off      */
   knopf=0;
   PRESS('e', knopf=-1 , knopf=1 );
   PRESS('n', nose -= .001 , nose += .001 );     /* for binoculars      */
   PRESS('s',speed /= 1.02, speed *= 1.02);      /* flying speed        */
   PRESS('q',torq /= 1.02, torq *= 1.02);        /* turning speed       */
   PRESS('o', focal *= 1.1 , focal /= 1.1)       /* telephoto           */
   PRESS('i', mysiz /= 1.1, mysiz *= 1.1)        /* rescale the world   */
   PRESS('p', farr *= 1.01 , farr   /= 1.01)       /* rear clipping plane */
   PRESS('z', deFault(), deFault());             /* zap changes         */
   PRESS('g',gap /= .9, gap *= .9);             /* gap parameter      */
   PRESS('a',amb /= .9, amb *= .9);             /* ambient fraction   */
   PRESS('r',pwr /= .9, pwr *= .9);             /* pseudo-spec power  */
   PRESS('j', dheta /=2, dheta *=2);
   PRESS('h', heta -=dheta, heta +=dheta);
   PRESS('b', beta -=.01, beta +=.01);
   CYCLE('u', umm, 3);
}
/**********************************************************************/
void special_keybo(int key, int x, int y){
/*non-ASCII keypresses go here, if you're lucky enough to know their names */
 fprintf(stderr," non-ASCII character was pressed.\n");
 fprintf(stderr," use special_keybo() to process it\n");
}
/**********************************************************************/
/**********************************************************/
/*** console speedometer                                  */
/**********************************************************/
float speedometer(void){
double dbl; static double rate; static int ii=0;

static struct _timeb lnow, lthen;

   if(++ii % 8 == 0){  /* 8 times around measure time */

	   _ftime(&lnow);
		dbl =  (double)(lnow.time - lthen.time)
			 +(double)(lnow.millitm - lthen.millitm)/1000;
		lthen = lnow;  rate = 8/dbl;
      }

   return((float)rate);
}

/**********************************************************************/
void char2wall(float x,float y,float z, char buf[]){
     char *p; glRasterPos3f(x,y,z);
     for(p = buf;*p;p++) glutBitmapCharacter(GLUT_BITMAP_9_BY_15,*p);
}
/**********************************************************************/
void messages(void){     
  char buf[256]; /* console messages are done differently from cave */
#define  LABEL2(x,y,W,u) {sprintf(buf,(W),(u));char2wall(x,y,0.,buf);}
  glMatrixMode(GL_PROJECTION); glPushMatrix(); glLoadIdentity();
  gluOrtho2D(0,3000,0,3000);
  glMatrixMode(GL_MODELVIEW); glPushMatrix(); glLoadIdentity();
      /*bull's eye*/
      if(mode==TURNMODE) glColor3f(0x22/255.,0x88/255.,0xdd/255.);
        else      glColor3f(.8,.8,.8);
      LABEL2(1500,1500,"%s","o");
      /* writings */
      if(mode==TURNMODE) glColor3f(1.,0.,1.);
        else      glColor3f(1.,1.,0.);
      LABEL2(80,80,"%4.1f fps",speedometer());
      LABEL2(80,2840,\
      "(ESC)ape (V)Binoc (MAUS2)Fore (BAR)Flymode %s ho(M)otopy (W)riting",
             mode?"FLYING":"CONTROL");
      LABEL2(10,10,"illiTangle\
 by Francis,Kauffman,Hartman, & Bourd, UIUC, 1993..2000 %s","");
      LABEL2(80,2770,"(N)ose   %0.3f",nose);
      LABEL2(80,2700,"(S)peed  %0.4f",speed);
      LABEL2(80,2630," tor(Q) %0.4f",torq);
      LABEL2(80,2560,"near clipper %g", mysiz*focal);
      LABEL2(80,2490,"f(O)cal factor %g",focal);
      LABEL2(80,2420,"my s(I)ze %.2g",mysiz);
      LABEL2(80,2350,"farr cli(P)er= %.2g",farr);
      LABEL2(80,2280,"(Z)ap %s","");
      LABEL2(80,2210,"(G)ap %.2g",gap);
      LABEL2(80,2140,"(A)mb %.2g",amb);
      LABEL2(80,2070,"(H)eta furl  %.4g",heta);
      LABEL2(80,2000,"(B)eta curl  %.4g",beta);
      LABEL2(80,1930,"(J)dheta %.4g ",dheta);
      LABEL2(80,1860,"(U)mm %d ",umm);
      LABEL2(80,1800,"for(E) %d ",knopf);
    glPopMatrix();
glMatrixMode(GL_PROJECTION); glPopMatrix();
} 
/**********************************************************************/
void chaptrack(int but,int xx,int yy,int shif){  
   long dx,dy; 
   dx = xx -.5*xt; dx = abs(dx)>5?dx:0;
   dy = yy -.5*yt; dy = abs(dy)>5?dy:0;

   glMatrixMode(GL_MODELVIEW); glPushMatrix(); glLoadIdentity();

   if(mode==TURNMODE) glTranslatef(aff[12],aff[13],aff[14]);
   glRotatef(dx*torq,0.,1.,0.); glRotatef(dy*torq,1.,0.,0.);
   if(but&(1<<GLUT_RIGHT_BUTTON ))glRotatef(shif?-10:-1,0.,0.,1.);
   if(but&(1<<GLUT_LEFT_BUTTON  ))glRotatef(shif?10:1,0.,0.,1.);
   if(mode==FLYMODE){
      glPushMatrix();
      glMultMatrixf(starmat);
      glGetFloatv(GL_MODELVIEW_MATRIX,starmat);
      glPopMatrix();
   }
   if(but&(1<<GLUT_MIDDLE_BUTTON  ))glTranslatef(0.,0.,shif ? -speed : speed);
   glTranslatef(0.,0.,knopf*speed);
   if(mode==TURNMODE) glTranslatef(-aff[12],-aff[13],-aff[14]);
   glMultMatrixf(aff); 
   glGetFloatv(GL_MODELVIEW_MATRIX,aff);
   FOR(ii,0,3){luxx[ii]=0; FOR(jj,0,3)luxx[ii] +=aff[ii*4+jj]*lux[jj];}
   glPopMatrix();
}
/**********************************************************************/
void reshaped(int xx, int yy){xt=xx ; yt=yy;}   /* origin of moved window */
/**********************************************************************/
void drawcons(void){  
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  if(binoc) glViewport(0,yt/4,xt/2,yt/2);
  glMatrixMode(GL_PROJECTION); glLoadIdentity();
  glFrustum(-mysiz*xt/yt,mysiz*xt/yt,-mysiz,mysiz,mysiz*focal,farr); 
  glMatrixMode(GL_MODELVIEW); glLoadIdentity();
  drawstars();
  glTranslatef(-binoc*nose,0.0,0.0);
  glMultMatrixf(aff);
  drawall();
  if(binoc){
    glViewport(xt/2,yt/4,xt/2,yt/2); 
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    drawstars();
    glTranslatef(binoc*nose,0.0,0.0);
    glMultMatrixf(aff);
    drawall();
    }
  glViewport(0,0,xt,yt);
  if(msg) messages();
  glutSwapBuffers();
}

/**********************************************************************/
void idle(void){ /*do this when nothing else is happening*/
   if(morph) autotymer(0);  /* advance autotymer */ 
   glutPostRedisplay();  /*redraw the window*/
   chaptrack(BUT,XX,YY,SHIF);
}

/**********************************************************************/
void mousepushed(int but,int stat,int x,int y){
  if(stat==GLUT_DOWN) BUT |= (1<<but);
  else BUT &= (-1 ^ (1<<but));  
  XX=x; YY=y; SHIF=(glutGetModifiers()==GLUT_ACTIVE_SHIFT)?1:0;
}

/**********************************************************************/
void mousemoved(int x,int y){  XX=x; YY=y; }
/**********************************************************************/
int main(int argc, char **argv){  
   arguments(argc,argv); 
   deFault(); 
 
       glutInit(&argc, argv);
       glutInitDisplayMode(GLUT_DOUBLE|GLUT_DEPTH);
       switch(win){ 
           case 0: break;  /* manage your own window */
           case 1: glutInitWindowSize(640, 480);
                   glutInitWindowPosition(100,100); break;
           case 2: glutInitWindowPosition(0,0); break;
         }
       glutCreateWindow("<* illiSkel in C/OpenGL/GLUT *>");
       if(win==2) glutFullScreen();
       glEnable(GL_DEPTH_TEST);
       glutDisplayFunc(drawcons);       
       glutKeyboardFunc(keyboard);
       glutSpecialFunc(special_keybo);
       glutMouseFunc(mousepushed);
       glutMotionFunc(mousemoved);       
       glutPassiveMotionFunc(mousemoved); 
       glutReshapeFunc(reshaped);
       glutIdleFunc(idle);             
       glutMainLoop();
}
